' This program is provided as Freeware for personal, educational
' and non-commercial use under a GNU General Public License.
'
' Written by Mike Perks (basicx@austin.rr.com), 2006
'
' Written for ZBasic Application Note AN-210
'
Option Explicit
Option Strict On

' private data for command queue
Private Const incCommand as Byte = &H80
Private cmdQueue(1 to 20) as Byte
Private cmdProcessorStack(1 to 80) as Byte

' routine to process commands
Private Sub cmdProcessor()
	Dim cmd as Byte
	Do
		Call GetQueue(cmdQueue, cmd, 1)	' wait for command to process
		If cmd = incCommand Then
			' do counter increment here
			count = count + 1
		End If
	Loop
End Sub

Private TaskStack(1 to 50) as Byte	' task stack
Private count as Integer 			' counter

' main routine
Public Sub Main()
	Dim time as Single
	time = Timer()
	
	' start command processor task
	Call OpenQueue(cmdQueue, Sizeof(cmdQueue))
	CallTask "cmdProcessor", cmdProcessorStack

	count = 0
	CallTask "counter", TaskStack
	
	Call Sleep(0) 
	Call Counter()

	' Wait for second task to finish if it hasn't already
	Call Sleep(1.0)
	Debug.Print "Final count is ";CStr(count);" after ";CStr(Fmt(Timer()-time,2));" seconds"	
End Sub

' common counting routine
Private Sub counter()
	Dim I as Integer
	Dim tempCount as Integer
	For I= 1 to 10
		' update counter
		tempCount = count
		Call Sleep(2)
		If (tempCount <> count) Then
			Debug.print CStr(Register.TaskCurrent);" wrong value"
			' Atomic version as a single output string
			'Debug.Print CStr(Register.TaskCurrent) & " wrong value" & Chr(&H0d) & Chr(&H0a);
		End If
		Call PutQueueByte(cmdQueue, incCommand)
	Next
End Sub